unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
  TAGraph, TASources, TASeries, TACustomSource;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    UserDefinedChartSource1: TUserDefinedChartSource;
    procedure FormCreate(Sender: TObject);
    procedure GetChartDatahandler(
      ASource: TUserDefinedChartSource; AIndex: Integer;
      var AItem: TChartDataItem);
  private
    ChartSource: TUserDefinedchartSource;
    Lineseries: TLineSeries;


  public

  end;

var
  Form1: TForm1;

type
  TDataPoint = record x, y: double; end;
  TDataArray = array of TDataPoint;

var
  Data: TDataArray;

implementation

{$R *.lfm}

uses
  TATypes;

procedure CreateData;
const
  N = 30;
var
  i: Integer;
  x, y: Double;
begin
  Setlength(Data, N);
  for i:=0 to N-1 do begin
    x := i + (Random-0.5) * 0.2;
    y := sin(x) + (random-0.5) * 0.1;
    Data[i].x := x;
    Data[i].y := y;
  end;
end;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  CreateData;

  ChartSource := TUserDefinedChartsource.Create(self);
  ChartSource.PointsNumber:= Length(Data);
  Chartsource.OnGetChartDataItem := @GetChartDataHandler;

  LineSeries := TLineSeries.Create(Chart1);
  LineSeries.Source := ChartSource;
  LineSeries.SeriesColor:= clRed;
  LineSeries.ShowPoints := true;
  LineSeries.Pointer.Style := psCircle;
  LineSeries.Pointer.Brush.Color := clRed;
  Chart1.AddSeries(LineSeries);
end;

procedure TForm1.GetChartDatahandler(
  ASource: TUserDefinedChartSource; AIndex: Integer; var AItem: TChartDataItem);
begin
  AItem.X := Data[AIndex].X;
  AItem.Y := Data[AIndex].Y;
end;

end.

